from functools import cmp_to_key
import re; StrtoG_parser = re.compile('"([1-9]):(([1-9][1-9][1-9])*)"')

def ItoG(i,n):
	G={}
	for (u,v,w) in Combinations(range(n),3):
		G[u,v,w] = i%2
		i //= 2
	return G
# ItoG

def GtoI(G,n):
	i=0
	bit=1
	for (u,v,w) in Combinations(range(n),3):
		i += bit*G[u,v,w]
		bit *= 2
	return i 
# GtoI

def StoG(s):
	match=StrtoG_parser.match(s)
	n=int(match.group(1))
	T=match.group(2)
	G=copy(emptyG[n])
	for i in range(len(T)/3):
		triple=tuple(map(lambda _: int(_)-1,[T[3*i],T[3*i+1],T[3*i+2]]))
		G[triple]=1
	return G
# StoG

def GtoS(G,n):
	res='    "%d:'%n
	for (u,v,w) in Combinations(range(n),3):
		if (G[u,v,w]==1): res+="%d%d%d"%(u+1,v+1,w+1)
	res+='"'
	return res
# GtoS

def LtoStr(L,n):
	res=sep=""
	for G in L:
		res+=sep+GtoS(G,n)
		sep=",\n"
	return res+"\n"
# LtoStr

def load_graph_list(file):
	ret=[]
	f=open(file)
	for line in f:
		s=line.strip()
		if (s[-1]==','): s=s[:-1]
		ret.append(StoG(s))
	return ret
# load_graph_list

def index(u,v,w): return tuple(sorted([u,v,w]))

def triple_count(G): return sum([G[t] for t in G])

def compareGH(G,H,n):
	diff = triple_count(G) - triple_count(H)
	if (diff != 0): return diff
	for (u,v,w) in Combinations(range(n),3):
		diff = H[u,v,w] - G[u,v,w]
		if (diff != 0): return diff
	return 0
# compareGH

def permuteG(G,pi):
	n=len(pi)
	H={}
	for (u,v,w) in Combinations(range(n),3): H[u,v,w]=G[index(pi[u],pi[v],pi[w])]
	return H
# permuteG

def get_minimalG(G,n):
	H=copy(G)
	for pi in Permutations(range(n))[1:]:
		H_try=permuteG(G,pi)
		for (u,v,w) in Combinations(range(n),3):
			diff=H_try[u,v,w] - H[u,v,w]
			if (diff==0): continue
			elif (diff > 0): H=H_try
			break
	#for pi
	return H
# get_minimalG

def get_minimalGlabel(G,n,l):
	H=copy(G)
	for pi in Permutations(range(l,n))[1:]:
		L=list(range(l))+list(pi)
		H_try=permuteG(G,L)
		for (u,v,w) in Combinations(range(n),3):
			diff = H_try[u,v,w] - H[u,v,w]
			if (diff==0): continue
			elif (diff > 0): H = H_try
			break
	#for pi
	return H
# get_minimalGlabel

def subgraphG(G,n,V):
	k=len(V)
	H=copy(emptyG[k])
	for (u,v,w) in Combinations(range(k),3): H[u,v,w] = G[index(V[u],V[v],V[w])]
	return H
# subgraphG

def findGiinL(Gi,L,n):
	res=0
	for Hi in L:
		if (Gi==Hi): return res
		else: res+=1
	return -1
#

def findGinL(G,L,n):
	res=0
	for H in L:
		if (compareGH(G,H,n)): res+=1
		else: return res
	return -1
#

def sublist(L,n,k):
	ret=[]
	triples=set(map(lambda x: index(x[0],x[1],x[2]),[(u,v,w) for u in range(k,n) for (v,w) in filter(lambda x: (not u in x),Combinations(range(n),2))]))
	for G in L:
		for u,v,w in triples:
			if (G[u,v,w]==1): break
		else:
			H=copy(G)
			for u,v,w in triples: H.pop((u,v,w))
			ret.append(H)
	return ret
#

def sort_and_uniqueL(L,n):
	size=len(L)
	if (size<=1): return L
	L_S=sorted(L, key=cmp_to_key(lambda G,H: compareGH(G,H,n)))
	res=[L_S[0]]
	for G in L_S[1:]:
		if (compareGH(res[-1],G,n)!=0): res.append(G)
	return res
# sort_and_uniqueL

def uniqmergeL(L1,L2,n):
	size1, size2 = len(L1), len(L2)
	if (size1==0) or (size2==0): return L1+L2
	res = []
	c1, c2 = 0, 0
	i1, i2 = iter(L1), iter(L2)
	G1, G2 = next(i1), next(i2)
	while (c1<size1) and (c2<size2):
		diff=compareGH(G1,G2,n)
		if (diff<0):
			res.append(G1)
			inc1=1
			inc2=0
		else:
			res.append(G2)
			inc2=1
			inc1=1 if (diff==0) else 0
		if (inc1):
			c1+=1
			if (c1<size1): G1=next(i1)
		if (inc2):
			c2+=1
			if (c2<size2): G2=next(i2)
	#while
	if (c1<size1):
		res.append(G1)
		for _ in range(c1+1,size1): res.append(next(i1))
	elif (c2<size2):
		res.append(G2)
		for _ in range(c2+1,size2): res.append(next(i2))
	return res
# uniqmergeL


emptyG=[]
for n in range(8):
	emptyG.append({})
	for (u,v,w) in Combinations(range(n),3): emptyG[-1][u,v,w]=0
