print("A.1: This script generates the file 'graph_lists/list7' containing the list of all 7-vertex K4minus-free 3-graphs.\n")

import multiprocessing, os; os.environ["SAGE_NUM_THREADS"] = str(multiprocessing.cpu_count())
from array import array
load("flags.sage")

def is_extension_K4e_free(G,n,new_triples):
	for (u,v,w) in Combinations(range(n-1),3):
		if (G[u,v,w] + new_triples[binomial(v,2)+u] + new_triples[binomial(w,2)+u] + new_triples[binomial(w,2)+v] > 2): return False
	return True
# is_extension_K4e_free

def extendG(G,n,new_triples):
	H=copy(G)
	for (u,v) in Combinations(range(n-1),2): H[u,v,n-1] = new_triples[binomial(v,2)+u]
	return H
# extendG

@parallel
def gen_extensionsG(Gi,n):
	G = ItoG(Gi,n)
	new_triples = array('B',[0]*binomial(n,2))
	res = [get_minimalG(extendG(G,n+1,new_triples),n+1)]
	while (True):
		for i in range(len(new_triples)):
			if (new_triples[i]==0):
				new_triples[i] = 1
				for j in range(i): new_triples[j] = 0
				if (is_extension_K4e_free(G,n+1,new_triples)): res.append(get_minimalG(extendG(G,n+1,new_triples),n+1))
				else: #optimization : adding more triples will keep the extension containing K4e
					for j in range(i): new_triples[j] = 1
				break
		else:
			break #end of the while-iteration over all the 2^binomial(n-1,2) extensions
	#while
	return sort_and_uniqueL(res, n+1)
# gen_extensionsG

def gen_list(n):
	if (n<3): return [{}] # the empty 3graph
	L = []
	all_extensions = list(gen_extensionsG([ {'Gi':i, 'n':n-1} for i in [GtoI(G,n-1) for G in gen_list(n-1)] ]))
	for (_,res) in all_extensions: L = uniqmergeL(L, res, n)
	return L
# gen_list

n = 7
directory="./graph_lists"
if (not os.path.exists(directory)): os.mkdir(directory)
f=open("%s/list%d"%(directory,n),"w")
_=f.write(LtoStr(gen_list(n),n))
f.close()
