print("A.2: This script generates the file 'flagmatic_flags-pruned.rat' and the supplementary 'graph_lists/list6_iota<i>' files.\n")

load("flags.sage")

F7=load_graph_list("graph_lists/list7")
F6=sublist(F7,7,6)
F5=sublist(F6,6,5)
iotas=[2,3,4,5,6,9]
flagmatic_block_shift=5
F6_iotas={}
for iota in iotas: F6_iotas[iota]=[]
for G in F6:
	for inj in Permutations(range(6)):
		H=permuteG(G,inj)
		root=subgraphG(H,6,range(5))
		iota=findGinL(root,F5,5)
		if (iota in iotas): F6_iotas[iota].append(H)
	#for inj
#for G
for iota in iotas: F6_iotas[iota] = sort_and_uniqueL(F6_iotas[iota],6)

directory="./graph_lists"
if (not os.path.exists(directory)): os.mkdir(directory)
for i in [1,2,3,4,5,6]:
	f=open("%s/list6_iota%d"%(directory,i),"w")
	_=f.write(LtoStr(F6_iotas[iotas[i-1]],6))
	f.close()
#for i
f=open("./flagmatic_flags-pruned.rat","w")
Gid=0
for G in F7:
	Gid+=1
	G_pair_dens={}
	for inj in Permutations(range(7),5):
		root=subgraphG(G,7,inj)
		iota=findGinL(root,F5,5)
		if (not iota in iotas): continue #prune only to iota_1, .., iota_6
		unlab=list(filter(lambda x: not x in inj, range(7)))
		left_id, right_id = [ findGinL(subgraphG(G,7,list(inj)+[unlab[i]]),F6_iotas[iota],6) for i in [0,1] ]
		key = (iota,min(left_id,right_id),max(left_id,right_id))
		add = 1+(left_id==right_id)
		if key in G_pair_dens: G_pair_dens[key] += add
		else: G_pair_dens[key] = add
	#for inj
	for (block,left_id,right_id) in sorted(G_pair_dens.keys()):
		frac = G_pair_dens[block,left_id,right_id] / 5040
		_=f.write("%d %d %d %d %d %d\n"%(Gid,block+flagmatic_block_shift,left_id+1,right_id+1,frac.numer(),frac.denom()))
	#for keys
#for G
f.close()
