print("A.4: This script generates the file 'ineq_tightpath' containing the coefficients of the expressions P_0, P_1 and P_2.\n")

load("flags.sage")

F7 = load_graph_list("graph_lists/list7")
F6 = sublist(F7,7,6)
F5 = sublist(F6,6,5)
F4 = sublist(F5,5,4)

F5_sigmas = [[],[],[]]
for G in F5:
	for inj in Permutations(range(5)):
		H = permuteG(G,inj)
		root = subgraphG(H,5,range(4))
		sigma = findGinL(root,F4,4) # sigma == -1 <-> the root is not the canonical sigma_0 / sigma_1 / sigma_2
		if (sigma >= 0): F5_sigmas[sigma].append(H)
	# for inj
# for G
for sigma in [0,1,2]: F5_sigmas[sigma] = sort_and_uniqueL(F5_sigmas[sigma],5)

P3_id = [[24,26,28,29,38,39],[19,20],[10,14]]
P_expression = []
for sigma in [0,1,2]:
	L=[F5_sigmas[sigma][index] for index in P3_id[sigma]]
	print("The set P_3^{sigma_%d} contains the following flags:\n%s\n"%(sigma,LtoStr(L,5)))
	expression = [-1]*len(F5_sigmas[sigma])
	for i in P3_id[sigma]: expression[i]+=16
	P_expression.append(expression)
# for sigma

pair_dens = []
for G in F7:
	G_pair_dens = [ {}, {}, {} ]
	for z in range(7):
		W=list(range(7)); W.remove(z)
		for inj in Permutations(W,4):
			root = subgraphG(G,7,inj)
			sigma = findGinL(root,F4,4)
			if (sigma < 0): continue
			unlab=list(filter(lambda x: not x in inj, W))
			left_id, right_id = [ findGinL(subgraphG(G,7,list(inj)+[unlab[i]]), F5_sigmas[sigma],5) for i in [0,1] ]
			key = (min(left_id,right_id), max(left_id,right_id))
			add = 1 + (left_id==right_id)
			if key in G_pair_dens[sigma]: G_pair_dens[sigma][key] += add
			else: G_pair_dens[sigma][key] = add
		# for inj
	# for z
	pair_dens.append(G_pair_dens)
# for G


f=open("./ineq_tightpath","w")
for sigma in [0,1,2]:
	G_index = 0
	sep=''
	for G in F7:
		value = 0
		for (left_id, right_id) in pair_dens[G_index][sigma]:
			value += pair_dens[G_index][sigma][left_id, right_id] * P_expression[sigma][left_id] * P_expression[sigma][right_id] * (1+(left_id != right_id))
		frac = value / 5040
		_=f.write("%s%s" % (sep, str(frac)))
		sep=" "
		G_index += 1
	#for G
	_=f.write('\n')
# for sigma
f.close()
